diff --git a/include/config_directives.h b/include/config_directives.h
index f35666f36..b778f6163 100644
--- a/include/config_directives.h
+++ b/include/config_directives.h
@@ -58,6 +58,7 @@ CFGFUN(focus_on_window_activation, const char *mode);
 CFGFUN(show_marks, const char *value);
 CFGFUN(hide_edge_borders, const char *borders);
 CFGFUN(assign, const char *workspace);
+CFGFUN(assign_number, const char *num);
 CFGFUN(no_focus);
 CFGFUN(ipc_socket, const char *path);
 CFGFUN(restart_state, const char *path);
diff --git a/include/data.h b/include/data.h
index 69a79ade0..54333e049 100644
--- a/include/data.h
+++ b/include/data.h
@@ -546,7 +546,8 @@ struct Assignment {
         A_ANY = 0,
         A_COMMAND = (1 << 0),
         A_TO_WORKSPACE = (1 << 1),
-        A_NO_FOCUS = (1 << 2)
+        A_NO_FOCUS = (1 << 2),
+        A_TO_WORKSPACE_NUMBER = (1 << 3)
     } type;
 
     /** the criteria to check if a window matches */
diff --git a/parser-specs/config.spec b/parser-specs/config.spec
index 4aa320bf6..8aca1296c 100644
--- a/parser-specs/config.spec
+++ b/parser-specs/config.spec
@@ -151,9 +151,15 @@ state ASSIGN_WORKSPACE:
       ->
   'workspace'
       ->
+  'number'
+      -> ASSIGN_WORKSPACE_NUMBER
   workspace = string
       -> call cfg_assign($workspace)
 
+state ASSIGN_WORKSPACE_NUMBER:
+  number = string
+      -> call cfg_assign_number($number)
+
 # no_focus <criteria>
 state NO_FOCUS:
   '['
diff --git a/src/config_directives.c b/src/config_directives.c
index 7ca6e1027..8ff9d1c65 100644
--- a/src/config_directives.c
+++ b/src/config_directives.c
@@ -390,6 +390,25 @@ CFGFUN(assign, const char *workspace) {
     TAILQ_INSERT_TAIL(&assignments, assignment, assignments);
 }
 
+CFGFUN(assign_number, const char *num) {
+    if (match_is_empty(current_match)) {
+        ELOG("Match is empty, ignoring this assignment\n");
+        return;
+    }
+    DLOG("New assignment, using above criteria, to workspace \"%s\".\n", num);
+
+    if (ws_name_to_number(num) == -1) {
+        ELOG("Could not parse initial part of \"%s\" as a number.\n", num);
+        return;
+    }
+
+    Assignment *assignment = scalloc(1, sizeof(Assignment));
+    match_copy(&(assignment->match), current_match);
+    assignment->type = A_TO_WORKSPACE_NUMBER;
+    assignment->dest.workspace = sstrdup(num);
+    TAILQ_INSERT_TAIL(&assignments, assignment, assignments);
+}
+
 CFGFUN(no_focus) {
     if (match_is_empty(current_match)) {
         ELOG("Match is empty, ignoring this assignment\n");
diff --git a/src/manage.c b/src/manage.c
index 86a361c37..9d52469a3 100644
--- a/src/manage.c
+++ b/src/manage.c
@@ -257,11 +257,21 @@ void manage_window(xcb_window_t window, xcb_get_window_attributes_cookie_t cooki
     const bool match_from_restart_mode = (match && match->restart_mode);
     if (nc == NULL) {
         Con *wm_desktop_ws = NULL;
+        Con *assigned_ws = NULL;
 
         /* If not, check if it is assigned to a specific workspace */
-        if ((assignment = assignment_for(cwindow, A_TO_WORKSPACE))) {
+        if ((assignment = assignment_for(cwindow, A_TO_WORKSPACE_NUMBER))) {
+            Con *output = NULL;
+            long parsed_num = ws_name_to_number(assignment->dest.workspace);
+
+            TAILQ_FOREACH(output, &(croot->nodes_head), nodes)
+            GREP_FIRST(assigned_ws, output_get_content(output),
+                       child->num == parsed_num);
+        }
+        if (assignment || (assignment = assignment_for(cwindow, A_TO_WORKSPACE))) {
             DLOG("Assignment matches (%p)\n", match);
-            Con *assigned_ws = workspace_get(assignment->dest.workspace, NULL);
+            if (!assigned_ws)
+                assigned_ws = workspace_get(assignment->dest.workspace, NULL);
             nc = con_descend_tiling_focused(assigned_ws);
             DLOG("focused on ws %s: %p / %s\n", assigned_ws->name, nc, nc->name);
             if (nc->type == CT_WORKSPACE)
